#include <Wire.h>
#include <Servo.h>           // Inkludiert die Servodateien 

Servo servo_direction;       

const byte interruptPin_left = 2;
const byte interruptPin_right = 3;
long time_difference;
long time_old_left;
long time_old_right;
long silence;
float angle;           // angle from where the sound is detected
float distance;       // distance of the two microphones


// ===========================
// =======   SETUP   =========
// ===========================

void setup()
   {
    Serial.begin(9600);

    servo_direction.attach(9);    // Set servo to digital pin 9
    
    pinMode(interruptPin_left, INPUT_PULLUP);
    pinMode(interruptPin_right, INPUT_PULLUP);
    
    //pinMode(interruptPin, INPUT);
    
    attachInterrupt(digitalPinToInterrupt(interruptPin_left), left, RISING);
    attachInterrupt(digitalPinToInterrupt(interruptPin_right), right, RISING);
    
    distance = 0.23;       // distance in meter of the two microphones

    time_old_left = 0;     // last trigger-time for left microphone
    time_old_right = 0;    // last trigger-time for right microphone

    silence = 80000;      // passed time in µsec within no trigger is accepted
   }


// ===========================
// =======    LOOP   =========
// ===========================

void loop()
   {
    time_difference = time_old_left - time_old_right;     // time difference of the received tone in µsec

    if(abs(330.0*(time_difference/1000000.0)) <= distance)
       {
        angle = asin(330.0*(time_difference/1000000.0)/distance);

        //angle = asin(-0.5);

        angle = angle * 180.0 / 3.141592654;

        angle = angle + 90.0;

        servo_direction.write(angle);
       }
    
    /*
    Serial.print("delta_t = ");
    Serial.print(time_difference);
    Serial.print("   angle = ");
    Serial.println(angle);
    */    
    
    delay(100);
    
   }



// ==============================
// =======   INTERRUPT  =========
// ==============================

void left()
   {
    if(micros() - time_old_left > silence)    // accepted new trigger after enough time has been passed
       {
        time_old_left = micros();
        /*
        Serial.print("left: ");
        Serial.println(time_old_left);
        */
       }  
   }


void right()
   {
    if(micros() - time_old_right > silence)   // accepted new trigger after enough time has been passed
       {
        time_old_right = micros();
        /*
        Serial.print("right: ");
        Serial.println(time_old_right);
        */
       }    
   }
